# ============================================================================================== #
#                                                                                                #
#                                     Galaxia Blockchain                                         #
#                                                                                                #
# ---------------------------------------------------------------------------------------------- #
# This file is part of the Xi framework.                                                         #
# ---------------------------------------------------------------------------------------------- #
#                                                                                                #
# Copyright 2018-2019 Xi Project Developers <support.xiproject.io>                               #
#                                                                                                #
# This program is free software: you can redistribute it and/or modify it under the terms of the #
# GNU General Public License as published by the Free Software Foundation, either version 3 of   #
# the License, or (at your option) any later version.                                            #
#                                                                                                #
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      #
# without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      #
# See the GNU General Public License for more details.                                           #
#                                                                                                #
# You should have received a copy of the GNU General Public License along with this program.     #
# If not, see <https://www.gnu.org/licenses/>.                                                   #
#                                                                                                #
# ============================================================================================== #

stages:
  - build
  - analyze
  - deploy

variables:
  GIT_SUBMODULE_STRATEGY: recursive

# ================================================================================================================== #
#                                                                                                                    #
#                                                        BUILD                                                       #
#                                                                                                                    #
# ================================================================================================================== #

.generic_build_template: &generic_build_definition
  stage: build
  dependencies: []
  script:
    - pwsh -File ./scripts/ci/Build.ps1
    - pwsh -File ./scripts/ci/Test.ps1
    - pwsh -File ./scripts/ci/DumpSymbols.ps1
    - pwsh -File ./scripts/ci/Package.ps1
  cache:
    key: "$CI_JOB_NAME"
    paths:
      - .build/
      - .hunter/
  artifacts:
    paths: [".packages/"]

.linux_build_template: &linux_build_definition
  <<: *generic_build_definition
  tags: ["docker"]

Ubuntu Bionic - Build:
  <<: *linux_build_definition
  image: registry.gitlab.com/galaxia-project/environment/ubuntu:bionic
  variables:
    CI_TARGET_OS: "Ubuntu Bionic"

Ubuntu Xenial - Build:
  <<: *linux_build_definition
  image: registry.gitlab.com/galaxia-project/environment/ubuntu:xenial
  variables:
    CI_TARGET_OS: "Ubuntu Xenial"

centOS 7 - Build:
  <<: *linux_build_definition
  image: registry.gitlab.com/galaxia-project/environment/centos:7
  variables:
    CI_TARGET_OS: "centOS 7"
  before_script: [". /opt/rh/devtoolset-8/enable"]

debian 9 - Build:
  <<: *linux_build_definition
  image: registry.gitlab.com/galaxia-project/environment/debian:9
  variables:
    CI_TARGET_OS: "debian 9"

fedora 29 - Build:
  <<: *linux_build_definition
  image: registry.gitlab.com/galaxia-project/environment/fedora:29
  variables:
    CI_TARGET_OS: "fedora 29"

openSuse Leap - Build:
  <<: *linux_build_definition
  image: registry.gitlab.com/galaxia-project/environment/opensuse:leap
  variables:
    CI_TARGET_OS: "openSuse Leap"

# Windows 10 - Build:
#   <<: *generic_build_definition
#   tags: ["windows"]
#   variables:
#     CI_TARGET_OS: "Windows 10"

# macOS - Build:
#   <<: *generic_build_definition
#   tags: ["macOS"]
#   variables:
#     CI_TARGET_OS: "macOS"

# ================================================================================================================== #
#                                                                                                                    #
#                                                      ANALYZE                                                       #
#                                                                                                                    #
# ================================================================================================================== #

CppCheck:
  stage: analyze
  image: registry.gitlab.com/galaxia-project/environment/cppcheck:latest
  tags: ["docker"]
  script: "/bin/bash ./scripts/ci/CppCheck.sh"
  dependencies: []
  artifacts:
    paths:
      - cppcheck.xml
      - .site/
  only:
    - develop
    - master

CppLint:
  stage: analyze
  image: registry.gitlab.com/galaxia-project/environment/cpplint:latest
  tags: ["docker"]
  dependencies: []
  script: "/bin/bash ./scripts/ci/CppLint.sh"
  artifacts:
    paths:
      - cpplint.xml
      - .site/
  only:
    - develop
    - master

# ================================================================================================================== #
#                                                                                                                    #
#                                                       DEPLOY                                                       #
#                                                                                                                    #
# ================================================================================================================== #

Packages:
  stage: deploy
  tags: ["windows"]
  dependencies:
    - "Ubuntu Bionic - Build"
    - "Ubuntu Xenial - Build"
    - "centOS 7 - Build"
    - "debian 9 - Build"
    - "fedora 29 - Build"
    - "openSuse Leap - Build"
    # - "Windows 10 - Build"
    # - "macOS - Build"
  script:
    - pwsh -File ./scripts/ci/DeployPackages.ps1
    - pwsh -File ./scripts/ci/NotifyRelease.ps1
  only:
    - develop
    - release-candidate
    - master
